<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWooOrder ArrayType
 * @subpackage Arrays
 */
class ArrayOfWooOrder extends AbstractStructArrayBase
{
    /**
     * The WooOrder
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WooOrder[]
     */
    public $WooOrder;
    /**
     * Constructor method for ArrayOfWooOrder
     * @uses ArrayOfWooOrder::setWooOrder()
     * @param \StructType\WooOrder[] $wooOrder
     */
    public function __construct(array $wooOrder = array())
    {
        $this
            ->setWooOrder($wooOrder);
    }
    /**
     * Get WooOrder value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WooOrder[]|null
     */
    public function getWooOrder()
    {
        return isset($this->WooOrder) ? $this->WooOrder : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWooOrder method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWooOrder method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWooOrderForArrayConstraintsFromSetWooOrder(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWooOrderWooOrderItem) {
            // validation for constraint: itemType
            if (!$arrayOfWooOrderWooOrderItem instanceof \StructType\WooOrder) {
                $invalidValues[] = is_object($arrayOfWooOrderWooOrderItem) ? get_class($arrayOfWooOrderWooOrderItem) : sprintf('%s(%s)', gettype($arrayOfWooOrderWooOrderItem), var_export($arrayOfWooOrderWooOrderItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WooOrder property can only contain items of type \StructType\WooOrder, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WooOrder value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WooOrder[] $wooOrder
     * @return \ArrayType\ArrayOfWooOrder
     */
    public function setWooOrder(array $wooOrder = array())
    {
        // validation for constraint: array
        if ('' !== ($wooOrderArrayErrorMessage = self::validateWooOrderForArrayConstraintsFromSetWooOrder($wooOrder))) {
            throw new \InvalidArgumentException($wooOrderArrayErrorMessage, __LINE__);
        }
        if (is_null($wooOrder) || (is_array($wooOrder) && empty($wooOrder))) {
            unset($this->WooOrder);
        } else {
            $this->WooOrder = $wooOrder;
        }
        return $this;
    }
    /**
     * Add item to WooOrder value
     * @throws \InvalidArgumentException
     * @param \StructType\WooOrder $item
     * @return \ArrayType\ArrayOfWooOrder
     */
    public function addToWooOrder(\StructType\WooOrder $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WooOrder) {
            throw new \InvalidArgumentException(sprintf('The WooOrder property can only contain items of type \StructType\WooOrder, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WooOrder[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WooOrder|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WooOrder|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WooOrder|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WooOrder|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WooOrder|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WooOrder
     */
    public function getAttributeName()
    {
        return 'WooOrder';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfWooOrder
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
