<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WooOrder StructType
 * @subpackage Structs
 */
class WooOrder extends AbstractStructBase
{
    /**
     * The orderHeader
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\WooOrderHeader
     */
    public $orderHeader;
    /**
     * The orderLines
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfWooOrderLine
     */
    public $orderLines;
    /**
     * Constructor method for WooOrder
     * @uses WooOrder::setOrderHeader()
     * @uses WooOrder::setOrderLines()
     * @param \StructType\WooOrderHeader $orderHeader
     * @param \ArrayType\ArrayOfWooOrderLine $orderLines
     */
    public function __construct(\StructType\WooOrderHeader $orderHeader = null, \ArrayType\ArrayOfWooOrderLine $orderLines = null)
    {
        $this
            ->setOrderHeader($orderHeader)
            ->setOrderLines($orderLines);
    }
    /**
     * Get orderHeader value
     * @return \StructType\WooOrderHeader|null
     */
    public function getOrderHeader()
    {
        return $this->orderHeader;
    }
    /**
     * Set orderHeader value
     * @param \StructType\WooOrderHeader $orderHeader
     * @return \StructType\WooOrder
     */
    public function setOrderHeader(\StructType\WooOrderHeader $orderHeader = null)
    {
        $this->orderHeader = $orderHeader;
        return $this;
    }
    /**
     * Get orderLines value
     * @return \ArrayType\ArrayOfWooOrderLine|null
     */
    public function getOrderLines()
    {
        return $this->orderLines;
    }
    /**
     * Set orderLines value
     * @param \ArrayType\ArrayOfWooOrderLine $orderLines
     * @return \StructType\WooOrder
     */
    public function setOrderLines(\ArrayType\ArrayOfWooOrderLine $orderLines = null)
    {
        $this->orderLines = $orderLines;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\WooOrder
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
